cfg = {}

--	Player frame.
function wPlayerFrame(self)
	local path = cfg.frameMode;
	if path == nil then
		path = "light"
	end
	if ( cfg.whoaTexture == true) then
		for i, v in pairs ({ self.healthbar, self.healthbar.AnimatedLossBar, PlayerFrameAlternateManaBar, }) do
			v:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName);	end
			
		for i, v in pairs ({ PlayerFrameMyHealPredictionBar, }) do
			v:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName); end
	end
	PlayerStatusTexture:ClearAllPoints();
	PlayerStatusTexture:SetPoint("CENTER", self, "CENTER",16, 8);
	PlayerLevelText:ClearAllPoints();
	PlayerLevelText:SetPoint("CENTER", self, "CENTER", -100, 200);
	PlayerFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame")
	PlayerStatusTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\UI-Player-Status");
	self.name:ClearAllPoints();
	self.name:SetPoint("CENTER", self, "CENTER",50.5, 36);
	self.healthbar:SetPoint("TOPLEFT",106,-24);
	self.healthbar:SetHeight(28);
	self.healthbar.LeftText:ClearAllPoints();
	self.healthbar.LeftText:SetPoint("LEFT",self.healthbar,"LEFT",5,0);
	self.healthbar.RightText:ClearAllPoints();
	self.healthbar.RightText:SetPoint("RIGHT",self.healthbar,"RIGHT",0,0);
	self.healthbar.TextString:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0);
	self.manabar.LeftText:ClearAllPoints();
	self.manabar.LeftText:SetPoint("LEFT",self.manabar,"LEFT",5,0)		;
	self.manabar.RightText:ClearAllPoints();
	self.manabar.RightText:SetPoint("RIGHT",self.manabar,"RIGHT",0,0);
	self.manabar.TextString:SetPoint("CENTER",self.manabar,"CENTER",0,0);
	PlayerFrameGroupIndicatorText:ClearAllPoints();
	PlayerFrameGroupIndicatorText:SetPoint("BOTTOMLEFT", self,"TOP",0,-20);
	PlayerFrameGroupIndicatorLeft:Hide();
	PlayerFrameGroupIndicatorMiddle:Hide();
	PlayerFrameGroupIndicatorRight:Hide();
end
hooksecurefunc("PlayerFrame_ToPlayerArt", wPlayerFrame)

function whoaUpdatePvPStatus()
	local path = cfg.frameMode;
	local factionGroup, factionName = UnitFactionGroup("player");
	if ( UnitIsPVPFreeForAll("player") ) then
		PlayerPVPIcon:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-PVP-FFA");
	elseif ( factionGroup and factionGroup ~= "Neutral" and UnitIsPVP("player") ) then
		PlayerPVPIcon:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-PVP-"..factionGroup);
	end
end
hooksecurefunc("PlayerFrame_UpdatePvPStatus", whoaUpdatePvPStatus)

function whoaPetFrameSelector(self, override)
	local path = cfg.frameMode;
	if ( (not PlayerFrame.animating) or (override) ) then
		if ( UnitIsVisible(self.unit) and PetUsesPetFrame() and not PlayerFrame.vehicleHidesPet ) then
			if ( UnitPowerMax(self.unit) == 0 ) then
				PetFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-SmallTargetingFrame-NoMana");
				
			else
				PetFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-SmallTargetingFrame");
			end
		end
	end
end
hooksecurefunc("PetFrame_Update", whoaPetFrameSelector)

--	Player vehicle frame.
function whoaVehicleFrame(self, vehicleType)
	if ( vehicleType == "Natural" ) then
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(103,12);
		self.healthbar:SetPoint("TOPLEFT",116,-41);
		self.manabar:SetSize(103,12);
		self.manabar:SetPoint("TOPLEFT",116,-52);
	else
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(100,12);
		self.healthbar:SetPoint("TOPLEFT",119,-41);
		self.manabar:SetSize(100,12);
		self.manabar:SetPoint("TOPLEFT",119,-52);
	end
	PlayerName:SetPoint("CENTER",50,23);
	PlayerFrameBackground:SetWidth(114);
end
-- hooksecurefunc("PlayerFrame_ToVehicleArt", whoaVehicleFrame)

	-- vehicle switch
local whoaStatusFrame = CreateFrame("Frame")
whoaStatusFrame:SetScript('OnEvent', function(self, event, ...)
	local arg1, arg2 = ...;
	if ( event == "UNIT_ENTERED_VEHICLE" ) then
		if ( arg1 == "player" ) then
			if ( arg2 ) then
				cfg.doVehicleFrame = true;
			end
		end
	elseif ( event == "UNIT_EXITED_VEHICLE" ) then
		cfg.doVehicleFrame = false;
	end
	return cfg.doVehicleFrame;
end)

	-- Vehicle color.
whoaStatusFrame:RegisterUnitEvent("PLAYER_ENTERING_WORLD");
whoaStatusFrame:RegisterUnitEvent("UNIT_ENTERED_VEHICLE");
whoaStatusFrame:RegisterUnitEvent("UNIT_EXITED_VEHICLE");
whoaStatusFrame:SetScript('OnUpdate', function(self)
	if ( cfg.doVehicleFrame ) then
		PlayerFrameHealthBar:SetStatusBarColor(whoaUnitColor("pet"));
		PetFrameHealthBar:SetStatusBarColor(whoaUnitColor("player"));
	else
		PlayerFrameHealthBar:SetStatusBarColor(whoaUnitColor("player"));
		if UnitExists("pet") then
			PetFrameHealthBar:SetStatusBarColor(whoaUnitColor("pet"));
		end
	end
	TargetFrameHealthBar:SetStatusBarColor(whoaUnitColor("target"));
	FocusFrameHealthBar:SetStatusBarColor(whoaUnitColor("focus"));
	TargetFrameToTHealthBar:SetStatusBarColor(whoaUnitColor("targettarget"));
	FocusFrameToTHealthBar:SetStatusBarColor(whoaUnitColor("focustarget"));
	--	party statusbar
	for i = 1, 4 do
		if i then
			_G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarColor(whoaUnitColor("party"..i));
		end
	end
	--	boss statusbar
	for i = 1, MAX_BOSS_FRAMES do
		if i then
			_G["Boss"..i.."TargetFrameHealthBar"]:SetStatusBarColor(whoaUnitColor("boss"..i));
		end
	end
end)

--	Player vehicle frame.
local function vehicleFrame(self, vehicleType)
		if ( vehicleType == "Natural" ) then
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Organic-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(103,12);
		self.healthbar:SetPoint("TOPLEFT",116,-41);
		self.manabar:SetSize(103,12);
		self.manabar:SetPoint("TOPLEFT",116,-52);
	else
		PlayerFrameVehicleTexture:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame");
		PlayerFrameFlash:SetTexture("Interface\\Vehicles\\UI-Vehicle-Frame-Flash");
		PlayerFrameFlash:SetTexCoord(-0.02, 1, 0.07, 0.86);
		self.healthbar:SetSize(100,12);
		self.healthbar:SetPoint("TOPLEFT",119,-41);
		self.manabar:SetSize(100,12);
		self.manabar:SetPoint("TOPLEFT",119,-52);
	end
	PlayerName:SetPoint("CENTER",50,23);
	PlayerFrameBackground:SetWidth(114);
end
hooksecurefunc("PlayerFrame_ToVehicleArt", vehicleFrame)

-- Pet frame
local function petFrame()
	PetFrameHealthBarTextRight:SetPoint("RIGHT",PetFrameHealthBar,"RIGHT",2,0);
	PetFrameManaBarTextRight:SetPoint("RIGHT",PetFrameManaBar,"RIGHT",2,-5);
	if (cfg.styleFont) then
		PetFrameHealthBarTextLeft:SetPoint("LEFT",PetFrameHealthBar,"LEFT",0,0);
		PetFrameHealthBarTextRight:SetPoint("RIGHT",PetFrameHealthBar,"RIGHT",2,0);
		PetFrameManaBarText:SetPoint("CENTER",PetFrameManaBar,"CENTER",0,-3);
		PetFrameManaBarTextLeft:SetPoint("LEFT",PetFrameManaBar,"LEFT",0,-3);
		PetFrameManaBarTextRight:SetPoint("RIGHT",PetFrameManaBar,"RIGHT",2,-3);
		PetFrameHealthBarText:SetFontObject(SystemFont_Outline_Small);
		PetFrameHealthBarTextLeft:SetFontObject(SystemFont_Outline_Small);
		PetFrameHealthBarTextRight:SetFontObject(SystemFont_Outline_Small);
		PetFrameManaBarText:SetFontObject(SystemFont_Outline_Small);
		PetFrameManaBarTextLeft:SetFontObject(SystemFont_Outline_Small);
		PetFrameManaBarTextRight:SetFontObject(SystemFont_Outline_Small);
	end
end
hooksecurefunc("PlayerFrame_ToPlayerArt", petFrame)

local function petFrameBg()
	local f = CreateFrame("Frame",nil,PetFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetSize(70,18);
	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetColorTexture(0, 0, 0, 0.5)
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("CENTER",16,-5);
	f:Show()
end
petFrameBg();